#include <vcl\vcl.h>
#pragma hdrstop
#include "Errors7.h"
#include "ddraw.h"

#pragma package(smart_init)

AnsiString GetOleError(HRESULT ErrorCode)
{
  AnsiString S;
  switch (ErrorCode)
  {
    case DDERR_ALREADYINITIALIZED: S = "Already Initialized"; break;
    case DDERR_CANNOTATTACHSURFACE: S = "Can't Attach Surface"; break;
    case DDERR_CANNOTDETACHSURFACE: S = "Can't Detach Surface"; break;
    case DDERR_CURRENTLYNOTAVAIL: S = "Currently Not Available"; break;
    case DDERR_EXCEPTION: S = "Exception"; break;
    case DDERR_GENERIC: S = "Generic Error"; break;
    case DDERR_HEIGHTALIGN: S = "Height Align"; break;
    case DDERR_INCOMPATIBLEPRIMARY: S = "Incompatible Primary"; break;
    case DDERR_INVALIDCAPS: S = "Invalid Caps"; break;
    case DDERR_INVALIDCLIPLIST: S = "Invalid Clip List"; break;
    case DDERR_INVALIDMODE: S = "Invalid Mode"; break;
    case DDERR_INVALIDOBJECT: S = "Invalid Object"; break;
    case DDERR_INVALIDPARAMS: S = "Invalid Parameters"; break;
    case DDERR_INVALIDPIXELFORMAT: S = "Invalid Pixel Format"; break;
    case DDERR_INVALIDRECT: S = "Invalid Rectangle"; break;
    case DDERR_LOCKEDSURFACES: S = "Locked Surfaces"; break;
    case DDERR_NO3D: S = "No 3D"; break;
    case DDERR_NOALPHAHW: S = "No Alpha HW"; break;
    case DDERR_NOCLIPLIST: S = "No Clip List"; break;
    case DDERR_NOCOLORCONVHW: S = "No Color Conv HW"; break;
    case DDERR_NOCOOPERATIVELEVELSET: S = "No Cooperative Level Set"; break;
    case DDERR_NOCOLORKEY: S = "No Color Key"; break;
    case DDERR_NOCOLORKEYHW: S = "No Color Key HW"; break;
    case DDERR_NODIRECTDRAWSUPPORT: S = "No Direct Draw Support"; break;
    case DDERR_NOEXCLUSIVEMODE: S = "No Exclusive Mode"; break;
    case DDERR_NOFLIPHW: S = "No Flip HW"; break;
    case DDERR_NOGDI: S = "No GDI"; break;
    case DDERR_NOMIRRORHW: S = "No Mirror HW"; break;
    case DDERR_NOTFOUND: S = "Not Found"; break;
    case DDERR_NOOVERLAYHW: S = "No Overlay HW"; break;
    case DDERR_NORASTEROPHW: S = "No Raster HW"; break;
    case DDERR_NOROTATIONHW: S = "No Rotation HW"; break;
    case DDERR_NOSTRETCHHW: S = "No Streach HW"; break;
    case DDERR_NOT4BITCOLOR: S = "Not 4 Bit Color"; break;
    case DDERR_NOT4BITCOLORINDEX: S = "Not 4 Bit Color Index"; break;
    case DDERR_NOT8BITCOLOR: S = "Not 8 Bit Color"; break;
    case DDERR_NOTEXTUREHW: S = "No Texture HW"; break;
    case DDERR_NOVSYNCHW: S = "No Vertical Sync HW"; break;
    case DDERR_NOZBUFFERHW: S = "No Z Buffer HW"; break;
    case DDERR_NOZOVERLAYHW: S = "No Z Overlay HW"; break;
    case DDERR_OUTOFCAPS: S = "Out of Caps"; break;
    case DDERR_OUTOFMEMORY: S = "Out Of Memory"; break;
    case DDERR_OUTOFVIDEOMEMORY: S = "Out Of Video Memory"; break;
    case DDERR_OVERLAYCANTCLIP: S = "Overlay Can't Clip"; break;
    case DDERR_OVERLAYCOLORKEYONLYONEACTIVE: S = "Overlay Color Key Only One Active"; break;
    case DDERR_PALETTEBUSY: S = "Palette Busy"; break;
    case DDERR_COLORKEYNOTSET: S = "ColorKey Not Set"; break;
    case DDERR_SURFACEALREADYATTACHED: S = "Surface Already Attached"; break;
    case DDERR_SURFACEALREADYDEPENDENT: S = "Surface Already Dependent"; break;
    case DDERR_SURFACEBUSY: S = "Surface Busy"; break;
    case DDERR_SURFACEISOBSCURED: S = "Surface Is Obscured"; break;
    case DDERR_SURFACELOST: S = "Surface Lost"; break;
    case DDERR_SURFACENOTATTACHED: S = "Surface Not Attached"; break;
    case DDERR_TOOBIGHEIGHT: S = "Too Big Height"; break;
    case DDERR_TOOBIGSIZE: S = "Too Big Size"; break;
    case DDERR_TOOBIGWIDTH: S = "Too Big Width"; break;
    case DDERR_UNSUPPORTED: S = "Unsuported"; break;
    case DDERR_UNSUPPORTEDFORMAT: S = "Unsupported Format"; break;
    case DDERR_UNSUPPORTEDMASK: S = "Unsuported Mask"; break;
    case DDERR_VERTICALBLANKINPROGRESS: S = "Vertical Blank in Progress"; break;
    case DDERR_WASSTILLDRAWING: S = "Was Still Drawing"; break;
    case DDERR_XALIGN: S = "X Align"; break;
    case DDERR_INVALIDDIRECTDRAWGUID: S = "Invalid DD GUID"; break;
    case DDERR_DIRECTDRAWALREADYCREATED: S = "DD Already Created"; break;
    case DDERR_NODIRECTDRAWHW: S = "No DD HW"; break;
    case DDERR_PRIMARYSURFACEALREADYEXISTS: S = "Primary Surface already Exists"; break;
    case DDERR_NOEMULATION: S = "No Emulation"; break;
    case DDERR_REGIONTOOSMALL: S = "Region Too Small"; break;
    case DDERR_CLIPPERISUSINGHWND: S = "Clipper is using HWND"; break;
    case DDERR_NOCLIPPERATTACHED: S = "No Clipper Attached"; break;
    case DDERR_NOHWND: S = "No HWND"; break;
    case DDERR_HWNDSUBCLASSED: S = "HWND Sub classed"; break;
    case DDERR_HWNDALREADYSET: S = "HWND Already Set"; break;
    case DDERR_NOPALETTEATTACHED: S = "No Pallete Attached"; break;
    case DDERR_NOPALETTEHW: S = "No Pallete HW"; break;
    case DDERR_BLTFASTCANTCLIP: S = "BlitFast Can't Clip"; break;
    case DDERR_NOBLTHW: S = "No Blit HW"; break;
    case DDERR_NODDROPSHW: S = "No DD Rops HW"; break;
    case DDERR_OVERLAYNOTVISIBLE: S = "Overlay Not Visible"; break;
    case DDERR_NOOVERLAYDEST: S = "No Overlay Dest"; break;
    case DDERR_INVALIDPOSITION: S = "Invalid Position"; break;
    case DDERR_NOTAOVERLAYSURFACE: S = "Not an Overlay Surface"; break;
    case DDERR_EXCLUSIVEMODEALREADYSET: S = "Exclusive mode already set"; break;
    case DDERR_NOTFLIPPABLE: S = "Unable to Flip"; break;
    case DDERR_CANTDUPLICATE: S = "Can't Duplicate"; break;
    case DDERR_NOTLOCKED: S = "Not Locked"; break;
    case DDERR_CANTCREATEDC: S = "Can't Create DC"; break;
    case DDERR_NODC: S = "No DC"; break;
    case DDERR_WRONGMODE: S = "Invalid Mode"; break;
    case DDERR_IMPLICITLYCREATED: S = "Implicitlt Created"; break;
    case DDERR_NOTPALETTIZED: S = "Not Palettized"; break;
    case DDERR_UNSUPPORTEDMODE: S = "Unsuported Mode"; break;
    default:
      S = SysErrorMessage(ErrorCode);
    //if (S == "")
    // FmtStr(S, LoadStr(62211), OPENARRAY(TVarRec, (int(ErrorCode))));
  }
  return "GetOleError: " + S;
}



