//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SnakeUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "AWaveSound2"
#pragma link "E7_DDraw"
#pragma link "KeyComs"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
  DDDestroySurface(lpDDS_Tile);                  //Destroy Image
  DDDestroySurface(lpDDS_Food);                  //Destroy Image
  DDDestroySurface(lpDDS_Food2);
  for (int i = 0; i < 10; i++)
   DDDestroySurface(lpDDS_Snake[i]);             //Destroy Image
  for (int j = 0; j < 11; j++)
   DDDestroySurface(lpDDS_Wall[j]);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  AnsiString Pic;
  int i;

  randomize();                                   //Initialize Random Number
  Server("GET_LOCATION", true, true);            //Where am I?
  DDScene7->BackgroundBitmap = szDirectory + "Graphics\\Back.bmp";
  DD7->Init();                                   //Initialize Direct Draw 7
  Server("ECHO " + DD7->GetVersion(), true, true);

  Pic = szDirectory + "Graphics\\Tile.bmp";      //Load all images
  lpDDS_Tile = DDLoadBitmap(0, Pic, true, clPurple);
  Pic = szDirectory + "Graphics\\Food.bmp";
  lpDDS_Food = DDLoadBitmap(0, Pic, true, clPurple);
  Pic = szDirectory + "Graphics\\Food2.bmp";
  lpDDS_Food2 = DDLoadBitmap(0, Pic, true, clPurple);

  for(i = 0; i < 10; i++) {
    Pic = szDirectory + "Graphics\\Snake_" + IntToStr(i) + ".bmp";
    lpDDS_Snake[i] = DDLoadBitmap(0, Pic, true, clPurple);
  }

  for(i = 0; i < 11; i++) {
    Pic = szDirectory + "Graphics\\Wall_" + IntToStr(i) + ".bmp";
    lpDDS_Wall[i] = DDLoadBitmap(0, Pic, true, clPurple);
  }

  Sound2->Init(2, 11025, 16);                    //Initialize Win Sound
  Server("ECHO " + Sound2->GetWaveFormat(), true, true);

  Server("EXEC CONFIG.CFG", true, true);
  GameActive = false;
  ResolutionChange();                            //Setup Resolution variables
  ResetVariables();                              //0 All Variables
  //Server("SHOW_MENU", false, true);
  //Clock->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if (int(Key == 223)) Console_P->Visible = !Console_P->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CKeyPress(TObject *Sender, char &Key)
{
  if (Key == VK_RETURN) {
    Key = NULL;                                  //Stop Beep
    Server(C_Edit->Text, true, false);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DInputDIKeyDown(TObject *Sender, int KeyNum)
{
  /*if (DInput->GetKeyName(KeyNum) == "`") {
    Console_P->Visible = !Console_P->Visible;
    C_Edit->Text = "";
  }
  else Server(DInput->GetCommand(KeyNum), true, true);*/
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if (Key == 223) {
    Console_P->Visible = !Console_P->Visible;
    C_Edit->Text = "";
  }
  else {
    Server(KeyComs->GetCommand(int(Key)), true, true);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MenuClick(TObject *Sender)
{
  if (Sender == NewGameB) {
    Server("NEW_GAME", true, true);
    MenuP->Visible = false;
    LevelGB->Visible = false;
    MazeGB->Visible = false;
  }

  else if ((Sender == LevelB) | (Sender == LOkB)) {
    LevelGB->Visible = !LevelGB->Visible;
    if (LevelGB->Visible) LevelTB->Position = Level;
    else {
      if (LevelTB->Position != Level)
       Server("LEVEL " + IntToStr(LevelTB->Position), true, true);
    }
  }

  else if ((Sender == MazeB) | (Sender == MOkB) | (Sender == MazeList)) {
    MazeGB->Visible = !MazeGB->Visible;
    if (MazeGB->Visible) MazeList->FileName = szDirectory + szMazeName;
    else Server("SZMAZENAME " + ExtractFileName(MazeList->FileName), true, true);
  }
  else if (Sender == ExitB) Server("QUIT", false, false);
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::CheckTile(int XP, int YP, Directions Dir, int Check)
{
  bool Result;

  if (Dir == dLeft) {
    if (XP <= 0) return false;
    else XP--;
  }
  else if (Dir == dRight) {
    if (XP >= 19) return false;
    else XP++;
  }
  else if (Dir == dUp) {
    if (YP <= 0) return false;
    else YP--;
  }
  else if (Dir == dDown) {
    if (YP >= 11) return false;
    else YP++;
  }

  if (Grid[YP][XP] == Check) Result = true;
  else Result = false;

  return Result;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::ChoseImage(int XP, int YP)
{
  int SImage = 3;

  if (Grid[YP][XP] == Snake_Length) {
    if (CurDir_Grid[YP][XP] == 0) SImage = 9;
    if (CurDir_Grid[YP][XP] == 1) SImage = 8;
    if (CurDir_Grid[YP][XP] == 2) SImage = 6;
    if (CurDir_Grid[YP][XP] == 3) SImage = 7;
  }
  else {
    if ((OldDir_Grid[YP][XP] == 0) & (CurDir_Grid[YP][XP] == 0)) SImage = 0;
    if ((OldDir_Grid[YP][XP] == 1) & (CurDir_Grid[YP][XP] == 1)) SImage = 0;
    if ((OldDir_Grid[YP][XP] == 2) & (CurDir_Grid[YP][XP] == 2)) SImage = 1;
    if ((OldDir_Grid[YP][XP] == 3) & (CurDir_Grid[YP][XP] == 3)) SImage = 1;
    if ((OldDir_Grid[YP][XP] == 1) & (CurDir_Grid[YP][XP] == 3)) SImage = 2;
    if ((OldDir_Grid[YP][XP] == 2) & (CurDir_Grid[YP][XP] == 0)) SImage = 2;
    if ((OldDir_Grid[YP][XP] == 0) & (CurDir_Grid[YP][XP] == 3)) SImage = 3;
    if ((OldDir_Grid[YP][XP] == 2) & (CurDir_Grid[YP][XP] == 1)) SImage = 3;
    if ((OldDir_Grid[YP][XP] == 3) & (CurDir_Grid[YP][XP] == 1)) SImage = 4;
    if ((OldDir_Grid[YP][XP] == 0) & (CurDir_Grid[YP][XP] == 2)) SImage = 4;
    if ((OldDir_Grid[YP][XP] == 3) & (CurDir_Grid[YP][XP] == 0)) SImage = 5;
    if ((OldDir_Grid[YP][XP] == 1) & (CurDir_Grid[YP][XP] == 2)) SImage = 5;
  }

  return SImage;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::ChoseWallImg(int XP, int YP)
{
  int WImage;
  bool LTile = CheckTile(XP, YP, dLeft, 259);
  bool RTile = CheckTile(XP, YP, dRight, 259);
  bool UTile = CheckTile(XP, YP, dUp, 259);
  bool DTile = CheckTile(XP, YP, dDown, 259);

  if ((!LTile) & (!RTile) & ((UTile) | (DTile))) WImage = 0;
  else if ((!UTile) & (!DTile) & ((LTile) | (RTile))) WImage = 1;
  else if ((!LTile) & (UTile) & (RTile) & (!DTile)) WImage = 2;
  else if ((!LTile) & (!UTile) & (RTile) & (DTile)) WImage = 3;
  else if ((LTile) & (!UTile) & (!RTile) & (DTile)) WImage = 4;
  else if ((LTile) & (UTile) & (!RTile) & (!DTile)) WImage = 5;
  else if ((!LTile) & (UTile) & (RTile) & (DTile)) WImage = 6;
  else if ((LTile) & (!UTile) & (RTile) & (DTile)) WImage = 7;
  else if ((LTile) & (UTile) & (!RTile) & (DTile)) WImage = 8;
  else if ((LTile) & (UTile) & (RTile) & (!DTile)) WImage = 9;
  else if ((LTile) & (UTile) & (RTile) & (DTile)) WImage = 10;
  else WImage = 1;
  
  return WImage;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DoMoves()
{
  IPoint CurPos;
  IPoint NewPos;
  int X, Y;
  bool Food = false;
  bool bPlaceFood = true;
  float Temp;

  for (Y = 0; Y < 12; Y++) {
    for (X = 0; X < 20; X++) {
      if (Grid[Y][X] == Snake_Length) {          //Find head
        CurPos.X = X;
        CurPos.Y = Y;
        OldDir_Grid[Y][X] = int(Old_Direction);
        CurDir_Grid[Y][X] = int(Snake_Direction);
        break;
      }
    }
  }

  NewPos = GetNextMove(CurPos, Snake_Direction); //Move Head
  if (Grid[NewPos.Y][NewPos.X] < 260) {
    Server("ECHO Game Over", true, true);
    //Clock->Enabled = false;                      //Stop clock
    GameActive = false;
  }
  else {
    if (Grid[NewPos.Y][NewPos.X] >= 261) {       //Check for Food
      Server("SOUND PLAY Food.wav", true, true);
      if (Grid[NewPos.Y][NewPos.X] > 261) {      //Special Food
        Points += SpecialFood.TimeLeft * (2 + Level / 2);      //Increase Points
        SpecialFood.TimeLeft = 0;
        bPlaceFood = false;
      }
      else Points += Level;                      //Normal Food

      Temp = (Snake_Length * 10) - 70;
      if (Temp <= Points) {
        Snake_Length++;
        Grid[NewPos.Y][NewPos.X] = Snake_Length;
        Food = true;
      }
      else Grid[NewPos.Y][NewPos.X] = Snake_Length + 1;

      if (bPlaceFood) PlaceFood();               //Place more food
    }
    else Grid[NewPos.Y][NewPos.X] = Snake_Length + 1;

    OldDir_Grid[NewPos.Y][NewPos.X] = int(Snake_Direction);
    CurDir_Grid[NewPos.Y][NewPos.X] = int(Snake_Direction);
  }

  if (Food == true) return;                      //Must grow if eaten

  for (Y = 0; Y < 12; Y++) {                     //Reduce length of snake sections
    for (X = 0; X < 20; X++) {
      if (Grid[Y][X] == 1) {
        Grid[Y][X] = 260;
        OldDir_Grid[Y][X] = -1;
        CurDir_Grid[Y][X] = -1;
      }
      else if (Grid[Y][X] < 250) Grid[Y][X]--;   //Shorten Snake
    }
  }
  Old_Direction = Snake_Direction;               //Change old Direction
}
//---------------------------------------------------------------------------
IPoint __fastcall TMainForm::GetNextMove(IPoint CurPos, Directions NDir)
{
  IPoint NewPos = CurPos;

  if (NDir == dLeft) {
    if (CurPos.X <= 0) NewPos.X = 19;
    else NewPos.X--;
  }
  else if (NDir == dRight) {
    if (CurPos.X >= 19) NewPos.X = 0;
    else NewPos.X++;
  }
  else if (NDir == dUp) {
    if (CurPos.Y <= 0) NewPos.Y = 11;
    else NewPos.Y--;
  }
  else if (NDir == dDown) {
    if (CurPos.Y >= 11) NewPos.Y = 0;
    else NewPos.Y++;
  }

  return NewPos;
}
//---------------------------------------------------------------------------
inline int TMainForm::GetNum(int Limit)
{
  return random(Limit);
}
//---------------------------------------------------------------------------
bool TMainForm::IsOppisiteDirection(Directions TestDirection)
{
  bool OpDir = false;

  if ((Snake_Direction == dUp) & (TestDirection == dDown)) OpDir = true;
  if ((Snake_Direction == dDown) & (TestDirection == dUp)) OpDir = true;
  if ((Snake_Direction == dLeft) & (TestDirection == dRight)) OpDir = true;
  if ((Snake_Direction == dRight) & (TestDirection == dLeft)) OpDir = true;

  return OpDir;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LoadLevel()
{
  char F_Line[30];                             //Characters to read
  int X, Y, Num;

  ifstream File(szMazeName.c_str());           //Open file
  if (!File) return;

  for (Y = 0; Y < 12; Y++) {
    File.getline(F_Line, sizeof(F_Line));      //Read Line
    for (X = 0; X < 20; X++) {
      if (F_Line[X] == '0') Num = 260;
      else if (F_Line[X] == '1') Num = 259;
      //Num += 260;
      //Server("ECHO " + IntToStr(Num), true, true);
      TempGrid[Y][X] = Num;
    }
  }
  File.close();                                //Close File
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PlaceFood()
{
  int XF, YF;
  int Tries = 0;
  bool Done = false;

  while ((Done == false) || (Tries > 50)) {
    Tries++;
    XF = GetNum(20);
    YF = GetNum(12);
    if (Grid[YF][XF] == 260) {
      Grid[YF][XF] = 261;
      Done = true;
    }
  }

  if (!Done) {                                   //Not placed quick enough
    for (YF = 0; YF < 12; YF++) {
      for (XF = 0; XF < 20; XF++) {
        if (Grid[YF][XF] == 260) {
          Grid[YF][XF] = 261;
          break;
        }
      }
    }
  }
  if ((SpecialFood.TimeLeft == 0) & (GetNum(3) == 2)) PlaceSpecialFood();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PlaceSpecialFood()
{
  int XS, YS;
  int Tries2 = 0;
  bool Done2 = false;

  while ((Done2 == false) || (Tries2 > 20)) {
    Tries2++;
    XS = GetNum(20);
    YS = GetNum(12);
    if (Grid[YS][XS] == 260) {
      Grid[YS][XS] = 262;
      SpecialFood.TimeLeft = 20;
      SpecialFood.Location.X = XS;
      SpecialFood.Location.Y = YS;
      Done2 = true;
    }
  }

  if (!Done2) {                                  //Not placed quick enough
    for (YS = 0; YS < 12; YS++) {
      for (XS = 0; XS < 20; XS++) {
        if (Grid[YS][XS] == 260) {
          Grid[YS][XS] = 262;
          SpecialFood.Location.X = XS;
          SpecialFood.Location.Y = YS;
          SpecialFood.TimeLeft = 20;
          break;
        }
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ResetVariables()
{
  int X, Y;

  LoadLevel();
  Points = 0;                                    //Reset Score
  for (Y = 0; Y < 12; Y++) {
    for (X = 0; X < 20; X++) {
      Grid[Y][X] = TempGrid[Y][X];
      OldDir_Grid[Y][X] = -1;
      CurDir_Grid[Y][X] = -1;
    }
  }
  //ClockChange = 0;
  Clock->Tag = 0;
  Snake_Direction = dLeft;
  Snake_Length = 7;
  Grid[6][4] = 7;
  OldDir_Grid[6][4] = 2;
  CurDir_Grid[6][4] = 2;
  PlaceFood();
  SpecialFood.TimeLeft = 0;
  GameActive = true;

}
//---------------------------------------------------------------------------
void TMainForm::ResolutionChange()
{
  float Ratio;

  BltFx.dwSize = sizeof(BltFx);

  if (DD7->Resolution == tr800x600) {
    ImgRect = Rect(0, 0, 35, 35);
    BltFlags = 0;
  }
  else {
    Ratio = 800 / DD7->ScreenRect.right;
    ImgRect = Rect(0, 0, 35 / Ratio, 35 / Ratio);
    BltFlags = DDBLT_DDFX;
    if (DD7->Resolution < tr800x600)
     BltFx.dwDDFX = DDFXCAPS_BLTSHRINKX | DDFXCAPS_BLTSHRINKY;
    else
     BltFx.dwDDFX = DDFXCAPS_BLTSTRETCHX | DDFXCAPS_BLTSTRETCHY;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Server(AnsiString Comm1, bool gShow, bool gSnake)
{
  AnsiString C_Message = "";

  Comm1 = Comm1.Trim();                          //Remove any spaces L/R
  if (SplitComm(Comm1) == -1) return;            //Error splitting the command
  Comms[1] = Comms[1].UpperCase();               //Convert to upper case

  //---------------------------------------------\\
  if (Comms[1] == "+LEFT") {
    if (IsOppisiteDirection(dLeft) == false) {
      gShow = svShowMoves;
      Snake_Direction = dLeft;
      C_Message = "Left";
    }
    else C_Message = "Invalid";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "+RIGHT") {
    if (IsOppisiteDirection(dRight) == false) {
      gShow = svShowMoves;
      Snake_Direction = dRight;
      C_Message = "Right";
    }
    else C_Message = "Invalid";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "+UP") {
    if (IsOppisiteDirection(dUp) == false) {
      gShow = svShowMoves;
      Snake_Direction = dUp;
      C_Message = "Up";
    }
    else C_Message = "Invalid";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "+DOWN") {
    if (IsOppisiteDirection(dDown) == false) {
      gShow = svShowMoves;
      Snake_Direction = dDown;
      C_Message = "Down";
    }
    else C_Message = "Invalid";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "BIND") {
    //C_Message = DInput->Bind(Comms[2], Comms[3]);
    C_Message = KeyComs->Bind(Comms[2], Comms[3]);
  }
  //---------------------------------------------\\
  else if (Comms[1] == "ECHO") {
    int i;
    C_Message = "";
    for (i = 2; i < 17; i++) {
      if (Comms[i].Length() > 0) C_Message += Comms[i];
      C_Message += " ";
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "EXEC") {
    char F_Line[100];                            //Characters to read
    ifstream File(Comms[2].c_str());             //Open file
    if (!File) {
      //ShowMessage("Unable to open " + Comms[2]);
      return;
    }
    C_Message = "Execing " + Comms[2];
    while (!File.eof()) {                        //Loop until End of File
      File.getline(F_Line, sizeof(F_Line));      //Read Line
      Server(F_Line, false, true);
    }
    File.close();                                //Close File
  }
  //---------------------------------------------\\
  else if (Comms[1] == "GET_LOCATION") {
    char gDirectory[MAX_PATH];                   //Directory Size
    GetModuleFileName(NULL, gDirectory, MAX_PATH);
    szDirectory = gDirectory;
    szDirectory.Delete(szDirectory.Length() - 8, 9);
    C_Message = "Location: " + szDirectory;
  }
  //---------------------------------------------\\
  else if (Comms[1] == "NEW_GAME") {
    Clock->Enabled = false;                      //Stop all Moves
    ResetVariables();
    Clock->Enabled = true;
    C_Message = "Starting New Game...";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "LEVEL") {
    if (Comms[2].Length() == 0) {
      C_Message = "Level: " + IntToStr(Level);
    }
    else {
      if (Comms[2].ToInt() > 10) Comms[2] = "10";//No cheating
      Level = Comms[2].ToInt();
      if (Comms[2] == "1") Clock->Interval = 600;
      else if (Comms[2] == "2") Clock->Interval = 550;
      else if (Comms[2] == "3") Clock->Interval = 400;
      else if (Comms[2] == "4") Clock->Interval = 350;
      else if (Comms[2] == "5") Clock->Interval = 290;
      else if (Comms[2] == "6") Clock->Interval = 210;
      else if (Comms[2] == "7") Clock->Interval = 160;
      else if (Comms[2] == "8") Clock->Interval = 110;
      else if (Comms[2] == "9") Clock->Interval = 70;
      else if (Comms[2] == "10") Clock->Interval = 40;
      C_Message = "Level: " + IntToStr(Level);
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "PAUSE") Clock->Enabled = !Clock->Enabled;
  //---------------------------------------------\\
  else if (Comms[1] == "QUIT") {
    Clock->Enabled = false;
    Application->Terminate();
  }
  //---------------------------------------------\\
  else if (Comms[1] == "RANDOM") {
    if (Comms[2].Length() == 0) C_Message = "Number: " + IntToStr(GetNum(100));
    else C_Message = "Number: " + IntToStr(GetNum(Comms[2].ToInt()));
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SHOW_MENU") {
    MenuP->Visible = !MenuP->Visible;
    if ((GameActive) & (!MenuP->Visible)) Clock->Enabled = true;
    else Clock->Enabled = false;
    C_Message = "---------------------------------";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SOUND") {
    Comms[2] = Comms[2].UpperCase();             //Convert Comm2 to Uppercase

    if (Comms[2] == "PLAY") {
      AnsiString WF = szDirectory + "Sound\\" + Comms[3];
      Sound2->Play(WF, false, SND_ASYNC | SND_FILENAME | SND_NODEFAULT);
      C_Message = Sound2->CommReturn;
    }
    else {
      C_Message = Sound2->Exec_Comm(Comms[2]);
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SVSHOWMOVES") {
    if (Comms[2].Length() == 0)
     C_Message = "svShowMoves: " + IntToStr(svShowMoves);
    else {
      if (Comms[2].ToInt() > 1) Comms[2] == "1";
      svShowMoves = Comms[2].ToInt();
      C_Message = "svShowMoves: " + IntToStr(svShowMoves);
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SZMAZENAME") {
    if (Comms[2].Length() > 0) szMazeName = Comms[2];
    C_Message = "szMazeName: " + szMazeName;
  }
  //---------------------------------------------\\
  else if (Comms[1] == "UNBINDALL") {
    //DInput->UnBindAll();
    KeyComs->UnBindAll();
    C_Message = "Keys Unbound";
  }
  //---------------------------------------------\\
  else C_Message = Comms[1] + "is not a valid command";

  if (gShow == true) {                           //Show the return Message?
    if (C_Memo->Lines->Count >= 30) C_Memo->Lines->Delete(29);
    C_Memo->Lines->Insert(0, C_Message);
  }
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::SplitComm(AnsiString StartStr)
{
  int StringPos, Temp;
  int ArrayNum = 1;
  AnsiString TempComms[17];

  for (Temp = 1; Temp < 16; Temp++) {
    Comms[Temp] = "";                            //Clear Comms array
    TempComms[Temp] = "";
  }

  if (StartStr.Length() == 0) return -1;         //If no String
  StartStr = StartStr.Trim();                    //Clear Spaces

  for (StringPos = 0; StringPos <= StartStr.Length(); StringPos++) {
    if (StartStr.IsDelimiter(" ", StringPos) == true) {
      ArrayNum++;
    }
    if (StartStr.IsDelimiter("#", StringPos) == true) {
      return -1;
    }
    else TempComms[ArrayNum] += StartStr.c_str()[StringPos];
  }

  for (Temp = 1; Temp < 16; Temp++) {
    Comms[Temp] = TempComms[Temp].Trim();
  }
  return StringPos;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClockTimer(TObject *Sender)
{
  //RECT DGrid = Rect(0, 0, 35, 35);               //Image Size
  IPoint Scr;                                    //Screen Position
  int XPos, YPos;                                //Grid Position

  if (GameActive) {
    DoMoves();                                   //Move the Snake
    if (SpecialFood.TimeLeft > 0) {
      SpecialFood.TimeLeft--;
      if (SpecialFood.TimeLeft == 0) {
        Grid[SpecialFood.Location.Y][SpecialFood.Location.X] = 260;
      }
    }
  }

  DDScene7->WriteXY(50, 490, "Score: " + FloatToStr(Points) + "      ",
   RGB(50, 40, 200), RGB(192, 192, 192));
  if (SpecialFood.TimeLeft > 0)
   DDScene7->WriteXY(50, 520, "TimeLeft: " + IntToStr(SpecialFood.TimeLeft) + "  ",
   RGB(50, 40, 200), RGB(192, 192, 192));
  else
   DDScene7->WriteXY(50, 520, "                    ", RGB(50, 40, 200), RGB(192, 192, 192));



  for (YPos = 0; YPos < 12; YPos++) {
    for (XPos = 0; XPos < 20; XPos++) {
      Scr.X = (XPos * ImgRect.right) + 50;
      Scr.Y = (YPos * ImgRect.bottom) + 60;
      if (Grid[YPos][XPos] < 259)
       DDBlitFx(DDScene7->DDSurface, lpDDS_Snake[ChoseImage(XPos, YPos)], Scr, ImgRect, BltFlags, &BltFx);
      else if (Grid[YPos][XPos] == 259)
       DDBlitFx(DDScene7->DDSurface, lpDDS_Wall[ChoseWallImg(XPos, YPos)], Scr, ImgRect, BltFlags, &BltFx);
      else if (Grid[YPos][XPos] == 260)
       DDBlitFx(DDScene7->DDSurface, lpDDS_Tile, Scr, ImgRect, BltFlags, &BltFx);
      else if (Grid[YPos][XPos] == 261)
       DDBlitFx(DDScene7->DDSurface, lpDDS_Food, Scr, ImgRect, BltFlags, &BltFx);
       //DDBlitFast(DDScene7->DDSurface, lpDDS_Food, Scr, DGrid, &DD7->ScreenRect);
      else if (Grid[YPos][XPos] == 262)
       DDBlitFx(DDScene7->DDSurface, lpDDS_Food2, Scr, ImgRect, BltFlags, &BltFx);
       //DDBlitFast(DDScene7->DDSurface, lpDDS_Food2, Scr, DGrid, &DD7->ScreenRect);
    }
  }

  DD7->Flip();                                   //Draw the Surface
  Old_Direction = Snake_Direction;               //Change Direction
}
//---------------------------------------------------------------------------


