//---------------------------------------------------------------------------
#ifndef SnakeUnitH
#define SnakeUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <FStream.h>
#include <ExtCtrls.hpp>
#include <Math.h>
#include <Stdlib.h>
#include <Time.h>
#include <DDraw.h>
#include "E7_DDraw.h"
#include "AWaveSound2.h"
#include "KeyComs.h"
#include <ComCtrls.hpp>
#include <FileCtrl.hpp>
//---------------------------------------------------------------------------
#ifndef __IPOINT
#define __IPOINT
typedef struct {int X, Y;} IPoint;               //Integer equivelent of TPoint
#endif
enum Directions {dUp, dDown, dLeft, dRight};

struct TSpecialFood {
  IPoint Location;
  int TimeLeft;
};
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
  __published:
    TPanel *Console_P;
    TEdit *C_Edit;
    TMemo *C_Memo;
    TWaveSound2 *Sound2;
    TTimer *Clock;
    TE_DDraw *DD7;
    TE_DDSurface *DDScene7;
    TKeyComs *KeyComs;
    TPanel *MenuP;
    TButton *NewGameB;
    TButton *LevelB;
    TButton *MazeB;
    TGroupBox *LevelGB;
    TTrackBar *LevelTB;
    TButton *LOkB;
    TGroupBox *MazeGB;
    TFileListBox *MazeList;
    TButton *MOkB;
    TButton *ExitB;
    TLabel *Label1;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall CKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall CKeyPress(TObject *Sender, char &Key);
    void __fastcall ClockTimer(TObject *Sender);
    void __fastcall DInputDIKeyDown(TObject *Sender, int KeyNum);

    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall MenuClick(TObject *Sender);
    
  private:
    int ClockChange;
    int CurDir_Grid[13][21];                     //Current Directions
    bool GameActive;
    LPDIRECTDRAWSURFACE7 lpDDS_Food;             //Food Image
    LPDIRECTDRAWSURFACE7 lpDDS_Food2;            //Special Food
    LPDIRECTDRAWSURFACE7 lpDDS_Snake[10];        //Snake Images
    LPDIRECTDRAWSURFACE7 lpDDS_Tile;             //Tile Image
    LPDIRECTDRAWSURFACE7 lpDDS_Wall[11];         //Wall
    DDBLTFX BltFx;
    DWORD BltFlags;
    RECT ImgRect;
    int OldDir_Grid[13][21];                     //Old Directions
    Directions Old_Direction;
    float Points;
    Directions Snake_Direction;
    float Snake_Length;
    TSpecialFood SpecialFood;

    bool __fastcall CheckTile(int XP, int YP, Directions Dir, int Check);
    int __fastcall ChoseImage(int XP, int YP);
    int __fastcall ChoseWallImg(int XP, int YP);
    void __fastcall DoMoves();
    IPoint __fastcall GetNextMove(IPoint CurPos, Directions NDir);
    inline int GetNum(int Limit);
    void __fastcall LoadLevel();
    void __fastcall PlaceFood();
    void __fastcall PlaceSpecialFood();
    void __fastcall ResetVariables();
    void ResolutionChange();
  //protected:
    int Grid[13][21];                            //[Y][X]
    int TempGrid[13][21];
    bool IsOppisiteDirection(Directions TestDirection);

  public:
    int Level;
    AnsiString Comms[17];                        //Server Commands
    AnsiString szDirectory;                      //Program Location
    bool svShowMoves;
    AnsiString szMazeName;

    __fastcall TMainForm(TComponent* Owner);
    __fastcall ~TMainForm();
    int __fastcall SplitComm(AnsiString StartStr);
    void __fastcall Server(AnsiString Comm1, bool gShow, bool gSnake);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
